-- to do

import "GaranStuff.CMapins.Class";
import "GaranStuff.CMapins.VindarPatch";
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import "GaranStuff.CMapins.Strings";
import "GaranStuff.CMapins.Table";
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "GaranStuff.CMapins.QSButton";

euroFormat=(tonumber("1,000")==1);

mainVisible=true;
hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state
language=1;
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
currentCharacterName=string.gsub(localPlayer:GetName(),"~","_");

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

function UnloadPlugin()
	SaveData();

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	mainWindow:RemoveShellCommands();
--	mainWindow.MouseClick=nil;
end

function SaveData()

	local settings={};

	settings[#settings+1]={"Top",mainWindow:GetTop()/Turbine.UI.Display:GetHeight()};
	settings[#settings+1]={"Left",mainWindow:GetLeft()/Turbine.UI.Display:GetWidth()};
	settings[#settings+1]={"Opacity",mainWindow.opacity};

	settings[#settings+1]={"language",language};

	PatchDataSave( Turbine.DataScope.Character, "CMapinsSettings", settings);
end

function LoadData()
	-- load saved settings
	-- try to load saved annotations
end


CMapinsWindow = class( Turbine.UI.Window );

function CMapinsWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	self.MoveX=-1;
	self.MoveY=-1;
	self:SetBackColor(Turbine.UI.Color(0,0,0,0));

	self.cellWidth=40;
	self.cellHeight=20;
	-- load the settings and set the window position if possible, otherwise default to center
	local initHeight=self.cellHeight*4+19;
	local initWidth=self.cellWidth*5;
	local initLeft=(Turbine.UI.Display:GetWidth()-initWidth)/2/Turbine.UI.Display:GetWidth();
	local initTop=(Turbine.UI.Display:GetHeight()-initHeight)/2/Turbine.UI.Display:GetHeight();
	self.opacity=1;

	tmpSettings=PatchDataLoad(Turbine.DataScope.Character, "CMapinsSettings");
	if (tmpSettings~=nil) then
		if tostring(type(tmpSettings))=="table" then
			for index=1,#tmpSettings do
				if tostring(type(tmpSettings[index]))=="table" then
					if (tmpSettings[index][1]=="Top") then
						if euroFormat then
							initTop=tonumber((string.gsub(tmpSettings[index][2],"%.",",")));
						else
							initTop=tonumber((string.gsub(tmpSettings[index][2],",",".")));
						end
					elseif (tmpSettings[index][1]=="Left") then
						if euroFormat then
							initLeft=tonumber((string.gsub(tmpSettings[index][2],"%.",",")));
						else
							initLeft=tonumber((string.gsub(tmpSettings[index][2],",",".")));
						end
					elseif (tmpSettings[index][1]=="Opacity") then
						self.opacity=tmpSettings[index][2];
					elseif (tmpSettings[index][1]=="language") then
						if tonumber(tmpSettings[index][2])~=nil then
							language=tonumber(tmpSettings[index][2]);
						end
					elseif (tmpSettings[index][1]=="DataVersion") then
						priorDataVersion=tmpSettings[index][2];
					end
				end
			end
		end


		-- force initTop and initLeft to values (0-1) -- don't allow positioning off screen
		if initTop>1 then initTop=1 end
		if initLeft>1 then initLeft=1 end
		if initTop*Turbine.UI.Display:GetHeight()<-16 then initTop=-16/Turbine.UI.Display:GetHeight() end
		if initLeft<0 then initLeft=0 end
	end

	self:SetPosition( initLeft*Turbine.UI.Display:GetWidth(), initTop*Turbine.UI.Display:GetHeight());
	self:SetHeight(initHeight);
	self:SetWidth(initWidth);
	self:SetVisible(false);

	self:SetOpacity(0);

	self:SetText(Resource[language][2]);

	local mapin={}
	mapin[1]=0x70028BB5;--Lugz good
	mapin[2]=0x70028BC0;--Isen good
	mapin[3]=0x70028BC2;--TA good
	mapin[4]=0x70028BB0;--TR good
	mapin[5]=0x70028BBD;--LC good
	mapin[6]=0x70028BB2;--Lugz poor
	mapin[7]=0x70028BAF;--Isen poor
	mapin[8]=0x70028BB1;--TA poor
	mapin[9]=0x70028BB4;--TR poor
	mapin[10]=0x70028BB9;--LC poor
	mapin[11]=0x70028BB7;--Lugz crude
	mapin[12]=0x70028BB3;--Isen crude
	mapin[13]=0x70028BB6;--TA crude
	mapin[14]=0x70028BBE;--TR crude
	mapin[15]=0x70028BBF;--LC crude

	self.MovePanel=Turbine.UI.Control();
	self.MovePanel:SetParent(self);
	self.MovePanel:SetSize(self:GetWidth(),19);
	self.MovePanel.Icon1=Turbine.UI.Control();
	self.MovePanel.Icon1:SetParent(self.MovePanel);
	self.MovePanel.Icon1:SetSize(19,19);
	self.MovePanel.Icon1:SetBackground("GaranStuff/CMapins/Resources/move.tga");
	self.MovePanel.Icon1:SetMouseVisible(false);
	self.MovePanel.Icon2=Turbine.UI.Label();
	self.MovePanel.Icon2:SetParent(self.MovePanel);
	self.MovePanel.Icon2:SetPosition(19,3);
	self.MovePanel.Icon2:SetSize(self:GetWidth()-19,12);
	self.MovePanel.Icon2:SetBackground("GaranStuff/CMapins/Resources/move2.tga");
	self.MovePanel.Icon2:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.MovePanel.Icon2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.MovePanel.Icon2:SetText(Resource[language][2]);
	self.MovePanel.Icon2:SetMouseVisible(false);

	self.MovePanel:SetVisible(false);

	self.MovePanel.MouseDown=function(sender,args)
			self.MoveX=args.X;
			self.MoveY=args.Y;
			self.MovingIcon:SetLeft(args.X-12);
			self.MovingIcon:SetTop(args.Y-12);
			self.MovingIcon:SetSize(32,32);
			self.MovingIcon:SetBackground(0x410000dd)
--			self.MovingIcon:SetVisible(true);
	end

	self.MovePanel.MouseMove=function(sender,args)
		if self.Moving then
			self:SetOpacity(self.opacity);
		end
		if (self.MoveY>-1 ) then
			if (args.X~=self.MoveX or args.Y~= self.MoveY) then
				self.Moving=true;
				local newLeft=self:GetLeft()-(self.MoveX-args.X)
				local newTop=self:GetTop()-(self.MoveY-args.Y)
				if newLeft<0 then newLeft=0 end;
				if newLeft>(Turbine.UI.Display.GetWidth()-self:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-self:GetWidth() end;
				if newTop<-16 then newTop=-16 end;
				if newTop>(Turbine.UI.Display.GetHeight()-self:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-self:GetHeight() end;
				self:SetPosition(newLeft,newTop);
			end
		end
	end

	self.MovePanel.MouseUp=function(sender,args)
		self.MovingIcon:SetVisible(false);
		self.MoveX=-1;
		self.MoveY=-1;
		self.Moving=false;
	end

	self.QS={};
	for row=1,3 do
		local rowColor;
		if row==1 then
			rowColor=Turbine.UI.Color(0,1,0);
		elseif row==2 then
			rowColor=Turbine.UI.Color(.9,.9,0);
		else
			rowColor=Turbine.UI.Color(1,.3,0);
		end
		self.QS[row]={};
		for col=1,5 do
			self.QS[row][col]=QSButton(Turbine.UI.Lotro.ShortcutType.Skill,string.format("0x%x",mapin[(row-1)*5+col]));
			self.QS[row][col]:SetParent(self);
			self.QS[row][col]:SetBackColor(Turbine.UI.Color(0,0,0));
			self.QS[row][col]:SetFont(Turbine.UI.Lotro.Font.Verdana12);
			self.QS[row][col]:SetSize(self.cellWidth,self.cellHeight);
			self.QS[row][col]:SetForeColor(rowColor);
			self.QS[row][col]:SetPosition((col-1)*self.cellWidth,(row)*self.cellHeight+19);
			self.QS[row][col]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			self.QS[row][col]:SetText(Resource[language][col+3]);
		end
	end
	self.QS[3]=QSButton(Turbine.UI.Lotro.ShortcutType.Skill,"0x70028BC1");
	self.QS[3]:SetParent(self);
	self.QS[3]:SetBackColor(Turbine.UI.Color(0,0,0));
	self.QS[3]:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.QS[3]:SetSize(self:GetWidth(),self.cellHeight);
	self.QS[3]:SetPosition(0,19);
	self.QS[3]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.QS[3]:SetText(Resource[language][9]);

	self.MovingIcon=Turbine.UI.Control();
	self.MovingIcon:SetParent(self);
	self.MovingIcon:SetSize(32,32);
	self.MovingIcon:SetStretchMode(1); -- allows it to display past the parent's bounds
	self.MovingIcon:SetBackground(0x410081c0)
	self.MovingIcon:SetPosition(self:GetWidth()/2-15,self:GetHeight()-21);
	self.MovingIcon:SetMouseVisible(false);
	self.MovingIcon:SetVisible(false);

	self.KeyDown=function(sender, args)
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
--			mainWindow:SetVisible(false);
		end
		if ( args.Action == 268435579 ) then -- reposition UI
			mainWindow.MovePanel:SetVisible(not mainWindow.MovePanel:IsVisible());
			if mainWindow.MovePanel:IsVisible() then
				mainWindow:SetOpacity(1);
			else
				mainWindow:SetOpacity(0);
			end
		end
		if ( args.Action == 268435635 ) then -- toggle HUD
			hudVisible=not hudVisible;
			if hudVisible then
				mainWindow:SetVisible(mainVisible);
			else
				mainVisible=mainWindow:IsVisible();
				mainWindow:SetVisible(false);
			end
		end
	end

	self.MouseEnter=function(sender,args)
		self:SetOpacity(self.opacity);
	end
	self.MouseLeave=function(sender,args)
		if not self.MovePanel:IsVisible() then
			self:SetOpacity(0);
		end
	end

	self.MouseClick=function(sender,args)
		if not self.Moving and args.Button==2 then
			-- user right clicked on main window
		end
	end

	self:SetWantsKeyEvents(true);
	self:SetWantsUpdates(true)

	self.RemoveShellCommands=function(sender,args)
		Turbine.Shell.RemoveCommand(self.shellCmd)
	end

	self.shellCmd=Turbine.ShellCommand();
	local numberOfCommandsRegistered = Turbine.Shell.AddCommand("CMapins",self.shellCmd);

	self.shellCmd.Execute = function(sender, cmd, args)
		if (string.lower(cmd) == "CMapins") then
			local pos1=string.find(args," ",0,true);
			local command;
			if pos1~=nil and pos1>0 then
				command=string.lower(string.sub(args,1,pos1-1));
			else
				command=string.lower(args);
			end
			if (command=="show") then
				mainWindow:SetVisible(true);
				mainWindow:SetOpacity(1);
			elseif (command=="hide") then
				mainWindow:SetVisible(false);
				mainWindow:SetOpacity(0);
			elseif (command=="toggle") then
				mainWindow:SetVisible(not mainWindow:IsVisible());
				if mainWindow:IsVisible() then
					mainWindow:SetOpacity(1);
				else
					mainWindow:SetOpacity(0);
				end
			else
				Turbine.Shell.WriteLine("usage:");
				Turbine.Shell.WriteLine("  /CMapins show");
				Turbine.Shell.WriteLine("       Displays CMapins.");
				Turbine.Shell.WriteLine("  /CMapins hide");
				Turbine.Shell.WriteLine("       Hides CMapins.");
				Turbine.Shell.WriteLine("  /CMapins toggle");
				Turbine.Shell.WriteLine("       Toggles CMapins (shows it if it was hidden, hides it if it was showing).");
			end
		end
	end
	self.shellCmd.GetHelp = function(sender, cmd)
		return("usage:\n  /CMapins show\n       Displays CMapins.\n  /CMapins hide\n       Hides CMapins.\n  /CMapins toggle\n       Toggles CMapins (shows it if it was hidden, hides it if it was showing).");
	end

	self.shellCmd.GetShortHelp = function(sender, cmd)
		return("CMapins - usage: /CMapins show | hide | toggle");
	end
	self.SetLanguage=function()
		if mapStrings[language]==nil or type(mapStrings[language])~="table" then
			mapStrings[language]={};
		end
		self:SetText(Resource[language][2]);
	end
end


function CMapinsWindow:Update( sender, args )
	if (Plugins["CMapins"] ~= nil) and (not self.Loaded) then
		if not self.Refreshing then
			Turbine.Shell.WriteLine("CMapins "..Plugins["CMapins"]:GetVersion()..Resource[language][3]);
		end
		Plugins["CMapins"].Unload = function(self,sender,args)
			UnloadPlugin();
		end
		self:SetWantsUpdates(false);
	end
end

LoadData();

mainWindow=CMapinsWindow();

if priorDataVersion~=Plugins["CMapins"]:GetVersion() then
	-- perform version change auto update stuff
end

mainWindow:SetVisible(true);

--optWindow=OptionsWindow();
--debugWindow=DebugWindow();

--optWindow:SetZOrder(mapWindow:GetZOrder()+1);
--debugWindow:SetZOrder(mainWindow:GetZOrder());

